diff -urNb aodv-uu-0.7.2/aodv_rreq.c maodv-umd-0.7.2/aodv_rreq.c
--- aodv-uu-0.7.2/aodv_rreq.c	Thu May 22 19:11:35 2003
+++ maodv-umd-0.7.2/aodv_rreq.c	Fri Dec  5 17:42:32 2003
@@ -25,6 +25,7 @@
 #include "aodv-uu.h"
 #else
 #include <netinet/in.h>
+#include <linux/route.h>
 #include "aodv_rreq.h"
 #include "aodv_rrep.h"
 #include "routing_table.h"
@@ -36,6 +37,14 @@
 #include "seek_list.h"
 #include "defs.h"
 #include "debug.h"
+
+
+#ifdef MAODV
+#include "multicast_routing_table.h"
+#include "maodv_rreq.h"
+#include "maodv_ext.h"
+#endif
+
 #endif
 
 /* Comment this to remove packet field output: */
@@ -57,9 +66,15 @@
 #endif
 
 RREQ *NS_CLASS rreq_create(u_int8_t flags, u_int32_t dest_addr,
-			   u_int32_t dest_seqno, u_int32_t orig_addr)
+			   u_int32_t dest_seqno, u_int32_t orig_addr,
+                           u_int16_t grp_hcnt, u_int32_t grp_addr )
 {
     RREQ *rreq;
+#ifdef MAODV
+    int size = RREQ_SIZE;
+    GRP_REBUILD_EXT * gre;
+    GRP_MERGE_EXT * gme;
+#endif
 
     rreq = (RREQ *) aodv_socket_new_msg();
     rreq->type = AODV_RREQ;
@@ -86,6 +101,30 @@
     if (flags & RREQ_UNKNOWN_SEQNO)
 	rreq->u = 1;
 
+#ifdef MAODV
+
+    if (flags & RREQ_GRP_REBUILD ) {
+        gre = (GRP_REBUILD_EXT *) ((char *) rreq + size);
+        gre->type = GRE_TYPE;
+        gre->length = GRE_LENGTH;
+        gre->grp_hcnt = htons(grp_hcnt);
+
+        size += GRP_REBUILD_EXT_SIZE;
+    }
+
+    if ( rreq->r && rreq->j ) {
+        /* add merge extension */
+        gme = (GRP_MERGE_EXT *) ((char *) rreq + size);
+        gme->type = GME_TYPE;
+        gme->length = GME_LENGTH;
+        gme->res = 0;
+        gme->grp_addr = htonl(grp_addr);
+
+        size += GRP_MERGE_EXT_SIZE;
+    }
+
+#endif /* MAODV */
+
     DEBUG(LOG_DEBUG, 0, "Assembled RREQ %s", ip_to_str(dest_addr));
 #ifdef DEBUG_OUTPUT
     log_pkt_fields((AODV_msg *) rreq);
@@ -94,6 +133,44 @@
     return rreq;
 }
 
+void NS_CLASS rreq_send_ext(u_int32_t dest_addr, u_int32_t dest_seqno, 
+                        int ttl, u_int8_t flags, u_int16_t grp_hcnt,
+                        u_int32_t grp_addr )
+{
+    RREQ *rreq;
+    int i;
+    int size = RREQ_SIZE;
+
+    /* Check if we should force the gratuitous flag... (-g option). */
+    if (rreq_gratuitous)
+	flags |= RREQ_GRATUITOUS;
+
+#ifdef MAODV
+
+    if ( flags & RREQ_GRP_REBUILD ) {
+        DEBUG( LOG_DEBUG, 0, "RREQ_GRP_REBUILD_EXT set." );
+        size += GRP_REBUILD_EXT_SIZE;
+    }
+
+    if ( (flags & RREQ_JOIN) && (flags & RREQ_REPAIR) ) {
+        DEBUG( LOG_DEBUG, 0, "RREQ_GRP_MERGE_EXT set, group %s", ip_to_str(grp_addr) );
+        size += GRP_MERGE_EXT_SIZE;
+    }
+
+#endif /* MAODV */
+
+    /* Broadcast on all interfaces */
+    for (i = 0; i < MAX_NR_INTERFACES; i++) {
+	if (!DEV_NR(i).enabled)
+	    continue;
+	rreq = rreq_create(flags, dest_addr, dest_seqno, DEV_NR(i).ipaddr,
+            grp_hcnt, grp_addr );
+
+	aodv_socket_send((AODV_msg *) rreq, AODV_BROADCAST, size,
+                         ttl, &DEV_NR(i) );
+    }
+}
+
 void NS_CLASS rreq_send(u_int32_t dest_addr, u_int32_t dest_seqno, int ttl,
 			u_int8_t flags)
 {
@@ -108,13 +185,14 @@
     for (i = 0; i < MAX_NR_INTERFACES; i++) {
 	if (!DEV_NR(i).enabled)
 	    continue;
-	rreq = rreq_create(flags, dest_addr, dest_seqno, DEV_NR(i).ipaddr);
+	rreq = rreq_create(flags, dest_addr, dest_seqno, DEV_NR(i).ipaddr, 
+            0, 0 );
 	aodv_socket_send((AODV_msg *) rreq, AODV_BROADCAST, RREQ_SIZE, ttl,
 			 &DEV_NR(i));
     }
 }
 
-void NS_CLASS rreq_forward(RREQ * rreq, int ttl)
+void NS_CLASS rreq_forward(RREQ * rreq, int ttl, int size )
 {
     int i;
     /* FORWARD the RREQ if the TTL allows it. */
@@ -122,7 +200,7 @@
 	  ip_to_str(ntohl(rreq->orig_addr)), ntohl(rreq->rreq_id));
 
     /* Queue the received message in the send buffer */
-    rreq = (RREQ *) aodv_socket_queue_msg((AODV_msg *) rreq, RREQ_SIZE);
+    rreq = (RREQ *) aodv_socket_queue_msg((AODV_msg *) rreq, size );
 
     rreq->hcnt++;		/* Increase hopcount to account for
 				 * intermediate route */
@@ -131,10 +209,35 @@
     for (i = 0; i < MAX_NR_INTERFACES; i++) {
 	if (!DEV_NR(i).enabled)
 	    continue;
-	aodv_socket_send((AODV_msg *) rreq, AODV_BROADCAST, RREQ_SIZE, ttl,
+	aodv_socket_send((AODV_msg *) rreq, AODV_BROADCAST, size, ttl,
+			 &DEV_NR(i));
+    }
+}
+
+#ifdef MAODV
+void NS_CLASS rreq_forward_uni(RREQ * rreq, u_int32_t dest, int ttl, 
+    int size )
+{
+    int i;
+    /* FORWARD the RREQ if the TTL allows it. */
+    DEBUG(LOG_INFO, 0, "forwarding RREQ src=%s, rreq_id=%lu",
+	  ip_to_str(ntohl(rreq->orig_addr)), ntohl(rreq->rreq_id));
+
+    /* Queue the received message in the send buffer */
+    rreq = (RREQ *) aodv_socket_queue_msg((AODV_msg *) rreq, size );
+
+    rreq->hcnt++;		/* Increase hopcount to account for
+				 * intermediate route */
+
+    /* Send out on all interfaces */
+    for (i = 0; i < MAX_NR_INTERFACES; i++) {
+	if (!DEV_NR(i).enabled)
+	    continue;
+	aodv_socket_send((AODV_msg *) rreq, AODV_BROADCAST, size, ttl,
 			 &DEV_NR(i));
     }
 }
+#endif /* MAODV */
 
 void NS_CLASS rreq_process(RREQ * rreq, int rreqlen, u_int32_t ip_src,
 			   u_int32_t ip_dst, int ip_ttl, unsigned int ifindex)
@@ -144,6 +247,14 @@
     rt_table_t *rev_rt, *fwd_rt = NULL;
     u_int32_t rreq_orig, rreq_dest, rreq_orig_seqno, rreq_dest_seqno;
     u_int32_t rreq_id, rreq_new_hcnt, life;
+    int size;
+#ifdef MAODV
+    GRP_REBUILD_EXT *grb_ext=NULL;
+    GRP_MERGE_EXT *gmg_ext=NULL;
+    u_int32_t grp_addr;
+
+    grp_addr = 0;
+#endif
 
     rreq_id = ntohl(rreq->rreq_id);
     rreq_dest = ntohl(rreq->dest_addr);
@@ -152,6 +263,7 @@
     rreq_orig_seqno = ntohl(rreq->orig_seqno);
     rreq_new_hcnt = rreq->hcnt + 1;
 
+    size = rreqlen;
 
     DEBUG(LOG_DEBUG, 0, "ip_src=%s rreq_orig=%s rreq_dest=%s",
 	  ip_to_str(ip_src), ip_to_str(rreq_orig), ip_to_str(rreq_dest));
@@ -193,14 +305,36 @@
 	    DEBUG(LOG_INFO, 0, "RREQ include EXTENSION");
 	    /* Do something here */
 	    break;
+#ifdef MAODV
+        case RREQ_GRP_REBUILD_EXT:
+            DEBUG(LOG_INFO, 0, "RREQ includes group rebuild extension");
+            grb_ext=(GRP_REBUILD_EXT*)ext;
+            if(grb_ext->length!=GRE_LENGTH) {
+                grb_ext=NULL;
+            }
+            break;
+        case RREQ_GRP_MERGE_EXT:
+            DEBUG(LOG_INFO, 0, "RREQ includes group merge extension" );
+            gmg_ext = (GRP_MERGE_EXT *) ext;
+            if ( gmg_ext->length != GME_LENGTH ) {
+                gmg_ext = NULL;
+            } else {
+                grp_addr = ntohl(gmg_ext->grp_addr);
+            }
+            break;
+#endif
 	default:
-	    log(LOG_WARNING, 0, __FUNCTION__, "Unknown extension type %d",
-		ext->type);
+	    log(LOG_WARNING, 0, __FUNCTION__, "Unknown extension type." );
 	    break;
 	}
 	rreqlen -= AODV_EXT_SIZE(ext);
 	ext = AODV_EXT_NEXT(ext);
     }
+
+#ifdef MAODV
+    DEBUG(LOG_DEBUG, 0, "grp_addr: %s", ip_to_str(grp_addr));
+#endif /* MAODV */
+
 #ifdef DEBUG_OUTPUT
     log_pkt_fields((AODV_msg *) rreq);
 #endif
@@ -239,14 +373,17 @@
     }
     /**** END updating/creating REVERSE route ****/
 
-    /* BAD HACK for Internet gateway support: */
-    if (internet_gw_mode &&
-	this_host.gateway_mode &&
-	(rreq_dest & DEV_IFINDEX(ifindex).netmask) !=
-	(DEV_IFINDEX(ifindex).ipaddr & DEV_IFINDEX(ifindex).netmask)) {
-	rrep_send(rev_rt, NULL);
+#ifdef MAODV
+    if ( IN_MULTICAST(rreq_dest) ) {
+        DEBUG(LOG_DEBUG, 0, "MAODV RREQ process.");
+        /* TODO: Added multicast rreq support. */
+        maodv_rreq_process( rreq, rreqlen, ip_src, ip_dst,
+            ip_ttl, ifindex, grb_ext, size );
+
 	return;
     }
+#endif
+
     /* Are we the destination of the RREQ?, if so we should immediately send a
        RREP.. */
     if (rreq_dest == DEV_IFINDEX(ifindex).ipaddr) {
@@ -254,15 +391,47 @@
 	/* WE are the RREQ DESTINATION. Update the node's own
 	   sequence number to the maximum of the current seqno and the
 	   one in the RREQ. */
-	if (!rreq->u && this_host.seqno < rreq_dest_seqno)
-	    this_host.seqno = rreq_dest_seqno;
+        if (!rreq->u && this_host.seqno == rreq_dest_seqno)
+	    this_host.seqno++;
 
-	rrep_send(rev_rt, NULL);
+#ifdef MAODV
+        if ((rreq->j) && (rreq->r) && (gmg_ext != NULL)) {
+            mrt_table_t *mrt;
+            mrt=mrt_table_find(grp_addr);
+            if(mrt->am_leader && !mrt->in_repair){
+                /* recieved a rreq because i'm leader */
+                DEBUG(LOG_DEBUG, 0, "Received a RREQ[j] for me.  Should send RREP for group.");
+                /* make GRPH flag update */
+                mrt->grph_update_cnt=2;
+                rrep_send(rev_rt, NULL, RREP_REPAIR, grp_addr );
+            }
+        } else {
+            rrep_send(rev_rt, NULL, 0, 0);
+        }
+#else  /* MAODV */
+        rrep_send(rev_rt, NULL, 0, 0);
+#endif /* MAODV */
 
     } else {
-	/* We are an INTERMEDIATE node. - check if we have an active
-	 * route entry */
+        /* We are an intermediate node, first check if being gatewayed */
+
+        /* Internet gateway support: */
+        if (internet_gw_mode && this_host.gateway_mode &&
+	    (rreq_dest & DEV_IFINDEX(ifindex).netmask) !=
+            (DEV_IFINDEX(ifindex).ipaddr & DEV_IFINDEX(ifindex).netmask)) {
+		printf("In here!!!\n");
+            int metric = get_route_metric(rreq->dest_addr);
+            if(metric >= 0) {
+			printf("Good metric!!!\n");
+                RREP *rrep = rrep_create(0, 0, ++metric, rreq_dest,
+                    ++this_host.seqno, rev_rt->dest_addr, MY_ROUTE_TIMEOUT, 0);
+                aodv_socket_send((AODV_msg*)rrep, rev_rt->next_hop, RREP_SIZE,
+                    MAXTTL, &DEV_IFINDEX(rev_rt->ifindex));
+                return;
+            }
+        }
 
+	/* check if we have an active route entry */
 	fwd_rt = rt_table_find(rreq_dest);
 
 	if (fwd_rt && fwd_rt->state == VALID && !rreq->d &&
@@ -273,12 +442,12 @@
 	       enough (our destination sequence number for that route is
 	       larger than the one in the RREQ). */
 
-	    rrep_send(rev_rt, fwd_rt);
+	    rrep_send(rev_rt, fwd_rt, 0, 0);
 
 	    /* If the GRATUITOUS flag is set, we must also unicast a
 	       gratuitous RREP to the destination. */
 	    if (rreq->g) {
-		rrep_send(fwd_rt, rev_rt);
+		rrep_send(fwd_rt, rev_rt, 0, 0);
 
 		DEBUG(LOG_INFO, 0, "Sending G-RREP to %s with rte to %s",
 		      ip_to_str(rreq_dest), ip_to_str(rreq_orig));
@@ -292,7 +461,38 @@
 		rreq->u = 0;
 	    }
 
-	    rreq_forward(rreq, --ip_ttl);
+#ifdef MAODV
+            if (( rreq->j ) && ( rreq->r ) && (gmg_ext != NULL)) {
+                mrt_table_t * mrt;
+                mrt_nexthop_t * upstream;
+
+                /* if I am part of group, unicast up. */
+                /* else regular rreq */
+                DEBUG( LOG_DEBUG, 0, "Recieved a RREQ[jr], forwarding." );
+
+                mrt = mrt_table_find( grp_addr );
+                if (( mrt != NULL ) && 
+                    ( mrt->grp_leader_addr == rreq_dest ) &&
+                    ( mrt->is_router ) ) {
+                    /* one of the members of the >ip tree */
+
+                    /* find activated upstream */
+                    upstream = mrt_table_get_activated_upstream( mrt );
+                    if ( ! upstream ) {
+                        DEBUG( LOG_DEBUG, 0, "Odd State: no activated upstream, but not leader..." );
+                    } else {
+                        rreq_forward_uni(rreq, upstream->addr, --ip_ttl, size );
+                    }
+                } else {
+                    /* not part of > ip tree, just forward along */
+                    rreq_forward(rreq, --ip_ttl, size );              
+                }
+            } else {
+                rreq_forward(rreq, --ip_ttl, size );
+            }
+#else /* MAODV */
+                rreq_forward(rreq, --ip_ttl, size );
+#endif /* MAODV */
 
 	} else {
 	    DEBUG(LOG_DEBUG, 0, "RREQ not forwarded - ttl=0");
@@ -303,7 +503,7 @@
 /* Perform route discovery for a unicast destination */
 
 void NS_CLASS rreq_route_discovery(u_int32_t dest_addr, u_int8_t flags,
-				   struct ip_data *ipd)
+				   struct ip_data *ipd, u_int32_t grp_addr)
 {
     struct timeval now;
     rt_table_t *rt;
@@ -311,26 +511,51 @@
     u_int32_t dest_seqno;
     int ttl;
 #define TTL_VALUE ttl
+    u_int16_t grp_hcnt;
+
+#ifdef MAODV
+    mrt_table_t *mrt;
+#endif /* MAODV */
 
     gettimeofday(&now, NULL);
 
+#ifdef MAODV
+    /* for non-merge RREQs, grp_addr should always be zero, so
+       seek_list_find_mcast will act like seek_list_find. */
+    if(seek_list_find_mcast(dest_addr, grp_addr))
+    return;
+#else
     if (seek_list_find(dest_addr))
 	return;
+#endif
 
     /* If we already have a route entry, we use information from it. */
     rt = rt_table_find(dest_addr);
 
+    grp_hcnt = 0;
+
+#ifdef MAODV
+    mrt = NULL;
+    if(IN_MULTICAST(dest_addr)) {
+        mrt = mrt_table_find(dest_addr);
+    }
+#endif
+
     ttl = NET_DIAMETER;		/* This is the TTL if we don't use expanding
 				   ring search */
 
+#ifdef MAODV
+    if((rt == NULL) && (mrt == NULL)) {
+#else
     if (rt == NULL) {
+#endif
 	flags |= RREQ_UNKNOWN_SEQNO;
 	dest_seqno = 0;
 
 	if (expanding_ring_search)
 	    ttl = TTL_START;
 
-    } else {
+    } else if(rt != NULL) {
 
 	if (rt->flags & RT_INV_SEQNO) {
 	    flags |= RREQ_UNKNOWN_SEQNO;
@@ -346,12 +571,44 @@
 	if (timeval_diff(&rt->rt_timer.timeout, &now) <
 	    (2 * NET_TRAVERSAL_TIME))
 	    rt_table_update_timeout(rt, 2 * NET_TRAVERSAL_TIME);
+
+#ifndef MAODV
     }
+#else
+    } else {
 
-    rreq_send(dest_addr, dest_seqno, ttl, flags);
+	if ( mrt->grp_seqno == 0 ) {
+	    flags |= RREQ_UNKNOWN_SEQNO;
+	    dest_seqno = 0;
+	} else
+	    dest_seqno = mrt->grp_seqno;
+
+	if (expanding_ring_search) {
+            if ( mrt->leader_hcnt == 0xff ) {
+                ttl = TTL_START;
+            } else {
+                ttl = mrt->leader_hcnt + TTL_INCREMENT;
+    }
+	}
+
+        grp_hcnt = mrt->leader_hcnt;
+
+	/* A routing table entry waiting for a RREP should not be expunged
+	   before 2 * NET_TRAVERSAL_TIME... */
+        /* CHECK: timeouts not happening yet. */
+        /*
+	if (timeval_diff(&mrt->mrt_timer.timeout, &now) <
+	    (2 * NET_TRAVERSAL_TIME))
+	    mrt_table_update_timeout(mrt, 2 * NET_TRAVERSAL_TIME);
+        */
+    }
+#endif /* MAODV */
+
+    rreq_send_ext(dest_addr, dest_seqno, ttl, flags, grp_hcnt, grp_addr);
 
     /* Remember that we are seeking this destination */
-    seek_entry = seek_list_insert(dest_addr, dest_seqno, ttl, flags, ipd);
+    seek_entry = seek_list_insert(dest_addr, dest_seqno, ttl, flags, ipd, 
+        grp_hcnt, grp_addr);
 
     /* Set a timer for this RREQ */
     if (expanding_ring_search)
@@ -416,7 +673,7 @@
     /* Remember that we are seeking this destination and setup the
        timers */
     seek_entry = seek_list_insert(rt->dest_addr, rt->dest_seqno,
-				  ttl, flags, ipd);
+				  ttl, flags, ipd, 0, 0);
 
     if (expanding_ring_search)
 	timer_set_timeout(&seek_entry->seek_timer,
@@ -528,3 +785,56 @@
     list_detach(&bl->l);
     free(bl);
 }
+
+static int get_mask_bitlen(u_int32_t mask) {
+    int bits = 0;
+    while(mask) {
+        if(mask & 1) {
+            bits++;
+        }
+        mask >>= 1;
+    }
+    return bits;
+}
+
+int get_route_metric(u_int32_t dest_addr) {
+    FILE *routes;
+    char buff[1024];
+    u_int32_t dest, gw, mask, metric, flags;
+    int  valid_entry = 0, valid_metric = -1, valid_bitlen = -1, bitlen;
+
+    /* Open Linux route table for reading */
+    routes = fopen("/proc/net/route", "r");
+    if(routes == NULL) {
+        return -1;
+    }
+
+    /* Read and discard header line */
+    fgets(buff, sizeof(buff), routes);
+    while(!feof(routes)) {
+        fgets(buff, sizeof(buff), routes);
+        /* Iface Destination Gateway Flags RefCnt Use Metric
+         *         Mask MTU Window IRTT */
+        sscanf(buff, "%*s %x %x %x %*x %*x %x %x", &dest, &gw, &flags,
+                &metric, &mask);
+        if((flags & RTF_UP) && ((dest&mask) == (dest_addr&mask))) {
+            bitlen = get_mask_bitlen(mask);
+            if(!valid_entry) {
+                valid_entry++;
+                valid_metric = metric;
+                valid_bitlen = bitlen;
+            } else if(bitlen > valid_bitlen) {
+                valid_metric = metric;
+                valid_bitlen = bitlen;
+            } else if((bitlen == valid_bitlen) && (valid_metric > metric)) {
+                valid_metric = metric;
+            }
+        }
+    }
+    fclose(routes);
+
+    /* If we found a matching, valid route, return its metric; otherwise,
+     * return an invalid metric (-1) */
+    return valid_entry ? metric : -1;
+}
+
diff -urNb aodv-uu-0.7.2/aodv_rreq.h maodv-umd-0.7.2/aodv_rreq.h
--- aodv-uu-0.7.2/aodv_rreq.h	Mon Jun  9 06:43:40 2003
+++ maodv-umd-0.7.2/aodv_rreq.h	Thu Jul 17 18:03:41 2003
@@ -36,6 +36,7 @@
 #define RREQ_GRATUITOUS    0x4
 #define RREQ_DEST_ONLY     0x8
 #define RREQ_UNKNOWN_SEQNO 0x10
+#define RREQ_GRP_REBUILD   0x20
 
 typedef struct {
     u_int8_t type;
@@ -84,25 +85,34 @@
 
 #ifndef NS_NO_DECLARATIONS
 RREQ *rreq_create(u_int8_t flags, u_int32_t dest_addr,
-		  u_int32_t dest_seqno, u_int32_t orig_addr);
+		  u_int32_t dest_seqno, u_int32_t orig_addr,
+          u_int16_t grp_hcnt, u_int32_t grpaddr);
+void rreq_send_ext(u_int32_t dest_addr, u_int32_t dest_seqno, int ttl,
+          u_int8_t flags, u_int16_t grp_hcnt, u_int32_t grp_addr);
 void rreq_send(u_int32_t dest_addr, u_int32_t dest_seqno, int ttl,
 	       u_int8_t flags);
-void rreq_forward(RREQ * rreq, int ttl);
+void rreq_forward(RREQ * rreq, int ttl, int size);
 void rreq_process(RREQ * rreq, int rreqlen, u_int32_t ip_src,
 		  u_int32_t ip_dst, int ip_ttl, unsigned int ifindex);
 void rreq_route_discovery(u_int32_t dest_addr, u_int8_t flags,
-			  struct ip_data *ipd);
+			  struct ip_data *ipd, u_int32_t grp_addr);
 void rreq_record_timeout(void *arg);
 struct blacklist *rreq_blacklist_insert(u_int32_t dest_addr);
 void rreq_blacklist_timeout(void *arg);
 void rreq_local_repair(rt_table_t * rt, u_int32_t src_addr,
 		       struct ip_data *ipd);
 
+#ifdef MAODV
+void NS_CLASS rreq_forward_uni(RREQ * rreq, u_int32_t dest, int ttl, int size);
+#endif /* MAODV */
+
 #ifdef NS_PORT
 struct rreq_record *rreq_record_insert(u_int32_t orig_addr, u_int32_t rreq_id);
 struct rreq_record *rreq_record_find(u_int32_t orig_addr, u_int32_t rreq_id);
 struct blacklist *rreq_blacklist_find(u_int32_t dest_addr);
 #endif				/* NS_PORT */
+
+int get_route_metric(u_int32_t dest_addr);
 
 #endif				/* NS_NO_DECLARATIONS */
 
diff -urNb aodv-uu-0.7.2/aodv_socket.c maodv-umd-0.7.2/aodv_socket.c
--- aodv-uu-0.7.2/aodv_socket.c	Wed Jun 18 15:41:38 2003
+++ maodv-umd-0.7.2/aodv_socket.c	Mon Jun 30 13:53:46 2003
@@ -43,6 +43,12 @@
 #ifdef USE_IW_SPY
 #include "link_qual.h"
 #endif
+
+#ifdef MAODV
+#include "maodv_mact.h"
+#include "maodv_grph.h"
+#endif
+
 #endif				/* NS_PORT */
 
 #ifndef NS_PORT
@@ -93,10 +99,11 @@
     }
 
     if (nleft == 1)
-	sum += *(unsigned char *) w;
+    sum += *(unsigned char*)w;
                                 
     sum = (sum >> 16) + (sum & 0xffff);
     sum += (sum >> 16);          
+
     return ~sum;
 
 }
@@ -209,6 +216,8 @@
     if ((aodv_msg->type == AODV_RREP && ttl == 1 && dst == AODV_BROADCAST)) {
 	hello_process((RREP *) aodv_msg, len, ifindex);
 	return;
+/*    } else if ( dst == AODV_BROADCAST ) {
+        bcast_process( src, ifindex ); */
     }
 
     /* Make sure we add/update neighbors */
@@ -233,6 +242,16 @@
 	DEBUG(LOG_DEBUG, 0, "Received RREP_ACK");
 	rrep_ack_process((RREP_ack *) aodv_msg, len, src, dst);
 	break;
+#ifdef MAODV
+    case MAODV_MACT:
+        DEBUG(LOG_DEBUG, 0, "Received MACT");
+        mact_process((MACT *) aodv_msg);
+        break;
+    case MAODV_GRPH:
+        DEBUG(LOG_DEBUG, 0, "Received GRPH");
+        grph_process((GRPH *) aodv_msg, src, ttl);
+        break;
+#endif
     default:
 	log(LOG_WARNING, 0, __FUNCTION__,
 	    "Unknown msg type %u rcvd from %s to %s", aodv_msg->type,
@@ -361,7 +380,7 @@
     ip = (struct iphdr *) send_buf;
     ip->version = IPVERSION;
     ip->ihl = sizeof(struct iphdr) >> 2;
-    ip->tos |= IPTOS_PREC_NETCONTROL | IPTOS_LOWDELAY; /* Highest priority */
+    ip->tos = IPTOS_PREC_NETCONTROL | IPTOS_LOWDELAY; /* Highest priority */
     ip->tot_len = htons(totlen);
     ip->id = 0; /* Let IP set */
     ip->frag_off = htons(0x4000); /* Set Do Not Fragment bit */
@@ -378,6 +397,7 @@
     udp->dest = htons(AODV_PORT);
     udp->len = htons(len + sizeof(struct udphdr));
     
+    udp->check = 0;
     udp->check = in_udp_csum(ip->saddr, ip->daddr, udp->len, 
 			     ip->protocol, (unsigned short *)udp);
 
diff -urNb aodv-uu-0.7.2/aodv_timeout.c maodv-umd-0.7.2/aodv_timeout.c
--- aodv-uu-0.7.2/aodv_timeout.c	Tue May 27 12:32:58 2003
+++ maodv-umd-0.7.2/aodv_timeout.c	Wed Jun 25 17:46:09 2003
@@ -42,6 +42,12 @@
 #include "seek_list.h"
 #include "icmp.h"
 
+#ifdef MAODV
+#include "multicast_routing_table.h"
+#include "maodv_mact.h"
+#include "maodv_neighbor.h"
+#endif /* MAODV */
+
 extern int expanding_ring_search, local_repair;
 void route_delete_timeout(void *arg);
 
@@ -54,6 +60,10 @@
     struct timeval now;
     seek_list_t *seek_entry;
     rt_table_t *rt, *repair_rt;
+#ifdef MAODV
+    u_int32_t dest_addr;
+#endif
+
     seek_entry = (seek_list_t *) arg;
 
 #define TTL_VALUE seek_entry->ttl
@@ -97,10 +107,76 @@
 	    (2 * NET_TRAVERSAL_TIME))
 	    rt_table_update_timeout(rt, 2 * NET_TRAVERSAL_TIME);
 
-	rreq_send(seek_entry->dest_addr, seek_entry->dest_seqno,
-		  TTL_VALUE, seek_entry->flags);
+        rreq_send_ext(seek_entry->dest_addr, seek_entry->dest_seqno,
+            seek_entry->ttl, seek_entry->flags, seek_entry->grp_hcnt,
+            seek_entry->grp_addr);
+    } else {
+#ifdef MAODV
+        if(seek_entry->flags & RREQ_JOIN && !(seek_entry->flags & RREQ_REPAIR)) {
+            mrt_table_t *group_rec;
+            mrt_nexthop_t *upstream;
+
+            DEBUG(LOG_DEBUG, 0, "In special MCAST timeout segment");
+
+            /* try to join the group */
+            group_rec = mrt_table_find(seek_entry->dest_addr);
+            upstream = mact_activate_best_upstream(group_rec);
+
+            if(upstream) {
+                if(group_rec->is_broken) {
+                    /* we were repairing route */
+                    group_rec->is_broken = 0;
+                } else if(group_rec->is_gateway) {
+                    /* Gateway joining, not a member */
+                } else {
+                    /* we were able to select an upstream */
+                    group_rec->is_member = 1;
+                    DEBUG(LOG_DEBUG, 0, "Joined Group");
+                }
+            } else {
+                /* have to become leader ourselves */
+                if(group_rec->is_broken && !group_rec->is_member) {
+                    /* we are a router who lost his upstream */
+                    group_rec->is_broken = 0;
+                    mact_make_downstream_leader(group_rec);
+                    DEBUG(LOG_DEBUG, 0, "Link broke, make downstream leader.");
+                } else {
+                    if(group_rec->is_broken) {
+                        group_rec->is_broken = 0;
+                        DEBUG(LOG_DEBUG, 0, "Was broken, now fixed.");
+                    }
 
+                    mrt_table_become_leader(group_rec);
+                    DEBUG(LOG_DEBUG, 0, "Became group leader");
+                }
+            }
+
+            dest_addr = seek_entry->dest_addr;
+            if(seek_list_remove(seek_list_find(seek_entry->dest_addr))) {
+                if(mcast_packet_queue_send(dest_addr) < 0) {
+                    DEBUG(LOG_DEBUG, 0, "Error dequeueing packets.");
+                }
     } else {
+                DEBUG(LOG_DEBUG, 0, "No longer in seek list.");
+            }
+
+            return;
+        } else if((seek_entry->flags & RREQ_JOIN) &&
+                (seek_entry->flags & RREQ_REPAIR)) {
+            mrt_table_t *mrt;
+            mrt = mrt_table_find(seek_entry->grp_addr);
+
+            if(mrt) {
+                /* Done merging, might have worked. */
+                DEBUG(LOG_DEBUG, 0, "Route discovery for merge timed out. Clearing in_repair.");
+                mrt->in_repair = 0;
+
+            } else {
+                DEBUG(LOG_DEBUG, 0, "Bad dest_addr:%d in seek_list.",
+                        ip_to_str(seek_entry->grp_addr));
+            }
+        }
+#endif /* MAODV */
 	packet_queue_drop(seek_entry->dest_addr);
 
 	DEBUG(LOG_DEBUG, 0, "NO ROUTE FOUND!");
@@ -113,7 +189,7 @@
 #endif
 	repair_rt = rt_table_find(seek_entry->dest_addr);
 
-	seek_list_remove(seek_entry);
+	seek_list_remove(seek_list_find(seek_entry->dest_addr));
 
 	/* If this route has been in repair, then we should timeout
 	   the route at this point. */
@@ -173,6 +249,31 @@
     precursor_list_destroy(rt);
 }
 
+#ifdef MAODV
+void NS_CLASS multicast_route_expire_timeout( void * arg )
+{
+    mrt_table_t *mrt;
+
+    mrt = (mrt_table_t *) arg;
+
+    if ( !mrt ) {
+        log( LOG_WARNING, 0, __FUNCTION__, "arg was NULL, ignoring timeout!" );
+        return;
+    }
+
+    DEBUG( LOG_DEBUG, 0, "Multicast Route %s DOWN, seqno = %d",
+        ip_to_str( mrt->grp_addr ), mrt->grp_seqno );
+
+/*
+    CHECK: Remove after creating valid flag.
+
+    mrt_table_invalidate( mrt );
+    mrt_nexthop_remove_all( mrt );
+*/
+
+    return;
+}
+#endif
 
 void NS_CLASS route_expire_timeout(void *arg)
 {
@@ -242,6 +343,9 @@
 #endif
 	}
 	neighbor_link_break(rt);
+#ifdef MAODV
+        mcast_neighbor_link_break(rt);
+#endif
     }
 }
 
diff -urNb aodv-uu-0.7.2/aodv_timeout.h maodv-umd-0.7.2/aodv_timeout.h
--- aodv-uu-0.7.2/aodv_timeout.h	Thu May 22 19:11:35 2003
+++ maodv-umd-0.7.2/aodv_timeout.h	Wed Jun 25 17:46:09 2003
@@ -31,6 +31,7 @@
 void route_delete_timeout(void *arg);
 void local_repair_timeout(void *arg);
 void route_discovery_timeout(void *arg);
+void multicast_route_expire_timeout(void *arg);
 void route_expire_timeout(void *arg);
 void hello_timeout(void *arg);
 void rrep_ack_timeout(void *arg);
diff -urNb aodv-uu-0.7.2/defs.h maodv-umd-0.7.2/defs.h
--- aodv-uu-0.7.2/defs.h	Mon Jun  9 06:43:40 2003
+++ maodv-umd-0.7.2/defs.h	Wed Jun 25 17:46:09 2003
@@ -27,13 +27,16 @@
 #include <unistd.h>
 #include <sys/time.h>
 #include <sys/types.h>
+#include <sys/socket.h>
 
 #ifndef NS_PORT
 #include <sys/signal.h>
+
 #include <netinet/in.h>
 #include <arpa/inet.h>
 #include <netinet/ip.h>
 #include <sys/ioctl.h>
+
 #endif
 
 #include <syslog.h>
@@ -94,6 +97,9 @@
     u_int32_t ipaddr;		/* The local IP address */
     u_int32_t netmask;		/* The netmask we use */
     u_int32_t broadcast;
+#ifdef MAODV
+    int injectfd;       /* Handle to IP injection device for this interface */
+#endif
 };
 
 struct host_info {
@@ -161,7 +167,6 @@
 
 #endif
 
-
 /* Two macros to simplify retriving of a dev_info struct. Either using
    an ifindex or a device number (index into devs array). */
 #define DEV_IFINDEX(ifindex) (this_host.devs[ifindex2devindex(ifindex)])
@@ -179,6 +184,12 @@
 #define AODV_RERR     3
 #define AODV_RREP_ACK 4
 
+#ifdef MAODV
+/* multicast types */
+#define MAODV_MACT    5
+#define MAODV_GRPH    6
+#endif /* MAODV */
+
 /* A generic AODV packet header struct... */
 #ifdef NS_PORT
 struct AODV_msg {
@@ -211,6 +222,13 @@
 #define RREQ_EXT 2
 #define RREP_EXT 2
 #define RREP_HELLO_NEIGHBOR_SET_EXT 3
+
+#ifdef MAODV
+/* MAODV Extension types */
+#define RREQ_GRP_REBUILD_EXT 4
+#define RREQ_GRP_MERGE_EXT 9
+#define RREP_GRP_MERGE_EXT 9
+#endif /* MAODV */
 
 /* An generic AODV extensions header */
 typedef struct {
diff -urNb aodv-uu-0.7.2/icmp.c maodv-umd-0.7.2/icmp.c
--- aodv-uu-0.7.2/icmp.c	Mon Oct  7 11:42:20 2002
+++ maodv-umd-0.7.2/icmp.c	Wed Jun 25 17:46:09 2003
@@ -33,7 +33,12 @@
 char icmp_send_buf[ICMP_BUFSIZE];
 int icmp_socket;
 
+/* Used in igmp.c's IGMP injection function */
+#ifdef MAODV
+unsigned short cksum(unsigned short *w, int len)
+#else
 static unsigned short cksum(unsigned short *w, int len)
+#endif
 {
     int sum = 0;
     unsigned short answer = 0;
diff -urNb aodv-uu-0.7.2/icmp.h maodv-umd-0.7.2/icmp.h
--- aodv-uu-0.7.2/icmp.h	Wed Jun 19 10:46:31 2002
+++ maodv-umd-0.7.2/icmp.h	Wed Jun 25 17:46:09 2003
@@ -24,5 +24,9 @@
 
 void icmp_init();
 int icmp_send_host_unreachable(char *data, int len);
+#ifdef MAODV
+/* MAODV packet injection needs an IP checksum function */
+unsigned short cksum(unsigned short *w, int len);
+#endif /* MAODV */
 
 #endif
